Imports System
Imports System.Collections
Imports System.Drawing
Imports System.Drawing.Drawing2D
Imports PDFTRON
Imports PDFTRON.PDF
Imports PDFTRON.Common


' <summary>
' A FreeHandAnnot is a list of FreeHand polygon strokes.
' </summary>
Public Class FreeHandAnnot
    Private _paths As ArrayList = New ArrayList

    Public Sub AddPath(ByVal path As GraphicsPath)
        _paths.Add(path)
    End Sub

    Public Sub DrawAnnots(ByVal g As Graphics, ByVal pen As Pen)
        Dim i As Integer = 0
        While i < _paths.Count ' Draw all FreeHand strokes
            g.DrawPath(pen, CType(_paths(i), GraphicsPath))
			i = i + 1
        End While
    End Sub
    Private _builder As ElementBuilder = New ElementBuilder
    Private _writer As ElementWriter = New ElementWriter

    Public Sub DrawAnnots(ByVal page As Page, ByVal pen As Pen)
        _writer.Begin(page) ' Begin writing to PDF page
        _builder.Reset()    ' Reset GState to default graphics state

        Dim inv_mtx As Matrix2D = page.GetDefaultMatrix()
        Dim x As Double
        Dim y As Double
        Dim i As Integer = 0
        While i < _paths.Count ' Draw all FreeHand strokes
            Dim p As GraphicsPath = CType(_paths(i), GraphicsPath)
            Dim pitr As GraphicsPathIterator = New GraphicsPathIterator(p)
            If pitr.Count > 0 Then
                Dim IsClosed As Boolean
                Dim numSubpaths As Integer = pitr.NextSubpath(p, IsClosed)
                _builder.PathBegin()
                Dim subPathPointType As Byte
                Dim pointTypeStartIndex As Integer
                Dim pointTypeEndIndex As Integer
                Dim numPointsFound As Integer
                numPointsFound = pitr.NextPathType(subPathPointType, pointTypeStartIndex, pointTypeEndIndex)
                While Not (numPointsFound = 0)
                    If subPathPointType = CType(PathPointType.Line, Byte) Then
                        x = p.PathPoints(pointTypeStartIndex).Y
                        y = p.PathPoints(pointTypeStartIndex).X
                        inv_mtx.Mult(x, y)
                        _builder.MoveTo(x, y)
                        Dim j As Integer = pointTypeStartIndex + 1
                        While j <= pointTypeEndIndex
                            x = p.PathPoints(j).Y
                            y = p.PathPoints(j).X
                            inv_mtx.Mult(x, y)
                            _builder.LineTo(x, y)
							j = j + 1
                        End While
                    End If
                    numPointsFound = pitr.NextPathType(subPathPointType, pointTypeStartIndex, pointTypeEndIndex)
                End While
                Dim element As Element = _builder.PathEnd   ' path geometry is completed
                element.SetPathFill(False)                  ' this path is should not filled
                element.SetPathStroke(True)

                ' Set the path color space and color
                Dim gstate As GState = element.GetGState
                gstate.SetStrokeColorSpace(ColorSpace.CreateDeviceRGB)
                Dim pc As Color = pen.Color
                gstate.SetStrokeColor(New ColorPt(pc.R / 255, pc.G / 255, pc.B / 255))
                gstate.SetLineWidth(1)
                _writer.WriteElement(element)
            End If
			i = i + 1
        End While
        _writer.End() ' save changes to the page
    End Sub
End Class
