' ---------------------------------------------------------------------------------------
' Copyright (c) 2001-2010 by PDFTron Systems Inc. All Rights Reserved.
' Consult legal.txt regarding legal and license information.
'---------------------------------------------------------------------------------------

Imports System
Imports System.IO
Imports System.Drawing
Imports System.Drawing.Printing
Imports System.Drawing.Drawing2D
Imports System.Drawing.Imaging
Imports System.Collections
Imports System.ComponentModel
Imports System.Windows.Forms
Imports PDFTRON
Imports PDFTRON.Common
Imports PDFTRON.Filters
Imports PDFTRON.SDF
Imports PDFTRON.PDF

Class PDFViewSecurityHandler
    Inherits StdSecurityHandler

    Public Sub New(ByVal key_len As Int32, ByVal enc_code As Int32)
        MyBase.New(key_len, enc_code)
    End Sub

    Public Sub New(ByVal s As PDFViewSecurityHandler)
        MyBase.New(s)
    End Sub
    ' In this callback ask the user for password/authorization data. 
    ' This may involve a dialog box used to collect authorization data or something else.
    Public Overloads Overrides Function GetAuthorizationData(ByVal p As SecurityHandler.Permission) As Boolean
        Dim dlg As AuthorizeDlg = New AuthorizeDlg
        If dlg.ShowDialog = DialogResult.OK Then
            InitPassword(dlg.pass.Text)
            Return True
        Else
            Return False
        End If
    End Function
    ' This callback could be used to customize security handler preferences.
    Public Overloads Overrides Function EditSecurityData(ByVal doc As SDFDoc) As Boolean
        Return False
    End Function
    ' This callback is used when authorization process fails.
    Public Overloads Overrides Sub AuthorizeFailed()
        MessageBox.Show("Authorize failed...", "PDFView Error")
    End Sub

    Public Shared Function Create(ByVal name As String, ByVal key_len As Int32, ByVal enc_code As Int32) As SecurityHandler
        Return New PDFViewSecurityHandler(key_len, enc_code)
    End Function

    Public Overloads Overrides Function Clone() As SecurityHandler
        Return New PDFViewSecurityHandler(Me)
    End Function
End Class
